﻿using Infragistics.Documents.Word;
using Infragistics.Win.DataVisualization;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ChartToWordDocument
{
    public partial class Form1 : Form
    {
        Random r = new Random();
        public Form1()
        {
            InitializeComponent();

            List<SampleData> data = new List<SampleData>();

            for (int i = 0; i < 12; i++)
            {
                data.Add(new SampleData() { Label = "Item " + i.ToString(), Value = r.Next(1, 10) });
            }

            UltraDataChart chart = new UltraDataChart() { Height = 400, Width = 400 };

            CategoryXAxis xAxis = new CategoryXAxis() { DataSource = data, Label = "Label" };
            NumericYAxis yAxis = new NumericYAxis() { MinimumValue = 0, MaximumValue = 10 };

            chart.Axes.Add(xAxis);
            chart.Axes.Add(yAxis);

            LineSeries series = new LineSeries() { XAxis = xAxis, YAxis = yAxis, DataSource = data, ValueMemberPath = "Value" };
            chart.Series.Add(series);

            chart.Flush();

            chart.SaveTo("Chart.png", System.Drawing.Imaging.ImageFormat.Png);

            WordDocumentWriter docWriter = WordDocumentWriter.Create(@"C:\TestWordDoc.docx");
            // Use inches as the unit of measure
            docWriter.Unit = UnitOfMeasurement.Point;

            docWriter.StartDocument();
            //  Start a paragraph
            docWriter.StartParagraph();         

            AnchoredPicture pic1 = AnchoredPicture.Create(docWriter, Image.FromFile("Chart.png"));
            AnchoredPicture pic2 = AnchoredPicture.Create(docWriter, Image.FromFile("Chart.png"));
            AnchoredPicture pic3 = AnchoredPicture.Create(docWriter, Image.FromFile("Chart.png"));
            AnchoredPicture pic4 = AnchoredPicture.Create(docWriter, Image.FromFile("Chart.png"));

            pic1.Size = new SizeF(50, 50);
            pic2.Size = new SizeF(100, 100);
            pic3.Size = new SizeF(150, 150);
            pic4.Size = new SizeF(200, 200);

            pic2.VerticalOffset = 50;
            pic3.VerticalOffset = 150;
            pic4.VerticalOffset = 300;

            docWriter.AddAnchoredPicture(pic1);
            docWriter.AddAnchoredPicture(pic2);
            docWriter.AddAnchoredPicture(pic3);
            docWriter.AddAnchoredPicture(pic4);

            //  End the paragraph
            docWriter.EndParagraph();
            //  End Document
            docWriter.EndDocument();
            // Close the writer
            docWriter.Close();
        }
    }

    public class SampleData
    {
        public string Label { get; set; }
        public int Value { get; set; }
    }
}
